// File: NotifySelf.java
// Test notify by seeing if a notify in a method 
//	can wake up a process waiting in the same method.

class Shared {

 synchronized void testNotify(String Name)
 { System.out.println("Name is "+Name+" Length is:"+Name.length());
   try {
     if (Name.equals("1")) {
	System.out.println("About to Wait -- Name Length is:"+Name.length());
	wait();
     }
     else if (Name.equals("2")) {
	try {	
	  Thread.sleep(100);
	}
	catch (Exception e) {
	  System.out.println(e);
	}
	notify();
     }
   } 
   catch (InterruptedException e)
   {}
   System.out.println("I am "+Name);
 }
}

public class NotifySelf extends Thread {

 Shared Share;

 public NotifySelf(Shared S,String n)
 {  super(n);
    Share=S;
//    Share.testNotify(getname());
 }

 public void run() 
 {  Share.testNotify(getName());
 }

 public static void main(String args[])
 { Shared S=new Shared();
   NotifySelf A=new NotifySelf(S,"1"),
	      B=new NotifySelf(S,"2");
   A.start();
   B.start();
 }

} // class